#USB_PID=$EF22
#USB_VID=$AAAA
#NO_Device="No HID device"
LoadFont(2,"Arial",22,#PB_Font_Bold)

Global R_DeviceHandle, W_DeviceHandle

Procedure FindDevice_Timer()
Static Old_Test
Test=HID_Lib_DeviceTest(#USB_PID, #USB_VID)
 If Test<>Old_Test
  Old_Test=Test 
  If Test 
    HID_Lib_CloseDevice(R_DeviceHandle) : HID_Lib_CloseDevice(W_DeviceHandle)
     W_DeviceHandle=HID_Lib_OpenDevice(#USB_PID, #USB_VID)
     R_DeviceHandle=HID_Lib_OpenDevice(#USB_PID, #USB_VID)
     SetGadgetText(0,"Discovered device")
  Else
     HID_Lib_CloseDevice(R_DeviceHandle) : HID_Lib_CloseDevice(W_DeviceHandle)
     R_DeviceHandle=0 : W_DeviceHandle=0
     SetGadgetText(0,#NO_Device)
     SetGadgetText(1,"OFF")
  EndIf
 EndIf
EndProcedure

Procedure ReadDevice_Thread(*x)
 Repeat
   If R_DeviceHandle
     HID_Lib_ReadDevice(R_DeviceHandle, @In, 4)
     ;select Function. 1=temp; 2=PortC
     If (in & $ff00)>>8 = 1 
       In=In>>16
       Result.f=In/16
       If Result<=125 And Result>-50
         SetGadgetText(1,StrF(Result,1)+" C")
       EndIf
     EndIf  
     If (in & $ff00)>>8 = 2
        For i=1 To 6
           If (((in & $ff0000)>>16) >> (i-1)) & $01 =  1
             SetGadgetText(11 + ((i-1)*2),"Up")
           Else
             SetGadgetText(11 + ((i-1)*2),"Down")
           EndIf
        Next i    
     EndIf
   EndIf
   Delay(100)
 ForEver
EndProcedure

Procedure SendDevice()
Command=0
Dim OutBytes.a(2)  
For i=8 To 3 Step -1
  If GetGadgetState(i)=1
    Command | 1
  Else
    Command & %11111110
  EndIf
  Command << 1
Next i
Command >> 1
If W_DeviceHandle
  OutBytes(0) = 0
  OutBytes(1) = Command
  HID_Lib_WriteDevice(W_DeviceHandle, @OutBytes(), 2)
Else
  MessageRequester("USB_Termo", #NO_Device, 16)
EndIf
EndProcedure


OpenWindow(0,0,0,230,220,"USB_Termo", #PB_Window_MinimizeGadget|#PB_Window_Invisible|#PB_Window_ScreenCentered)
 StickyWindow(0,1)
 TextGadget(0,4,4,162,16,#NO_Device,#PB_Text_Center)
 StringGadget(1,16,24,140,40,"OFF",#PB_Text_Center|#PB_String_ReadOnly)
   SetGadgetFont(1,FontID(2))
   SetGadgetColor(1,#PB_Gadget_FrontColor,$DF0000)

  Frame3DGadget(2,4,70,80,144,"Leds PORTB")
  y=88
  For i=1 To 6
    CheckBoxGadget(i+2,20,y,50,16,"Led "+Str(i))
    y+20
  Next i

  Frame3DGadget(9,100,70,120,144,"Buttons PORTC")
  y=88
  For i=1 To 6
    TextGadget(10 + ((i-1)*2),104,y,50,16,"Button "+Str(i)+":",#PB_Text_Right)
    TextGadget(11 + ((i-1)*2),160,y,50,16,"Up") : SetGadgetColor(11,#PB_Gadget_FrontColor,$C70000)
    y+20
  Next i
  
FindDevice_Timer()
HideWindow(0,0)

AddWindowTimer(0,1,400)
CreateThread(@ReadDevice_Thread(),0)

Repeat
   Event=WaitWindowEvent()
   If Event=#PB_Event_Timer
       If EventTimer()=1
         FindDevice_Timer()
       EndIf
  ElseIf Event=#PB_Event_Gadget
     Select EventGadget()
       Case 3 To 8
         SendDevice()
     EndSelect
   EndIf
Until Event=#PB_Event_CloseWindow
; IDE Options = PureBasic 4.40 Beta 6 (Windows - x86)
; CursorPosition = 92
; FirstLine = 48
; Folding = -
; EnableThread
; EnableXP
; UseIcon = Icon.ico
; Executable = USB_thermometer.exe
; SubSystem = UserLibThreadSafe
; CurrentDirectory = F:\___PureBasic\
; IncludeVersionInfo
; VersionField0 = 1.0.0.0
; VersionField1 = 1.0.0.0
; VersionField2 = Petr
; VersionField3 = USB_thermometer
; VersionField4 = 1.0
; VersionField5 = 1.0
; VersionField6 = USB_thermometer
; VersionField7 = USB_thermometer
; VersionField8 = USB_thermometer
; VersionField9 = Petr
; VersionField17 = 0409 English (United States)